<?xml version="1.0" encoding="iso8859-1" ?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns="http://www.w3.org/TR/xhtml1/strict">
    
    <xsl:output method="text" indent="yes" encoding="utf-8" />
   
    <xsl:template match="KimDaBa" >
/* Some initialisation variables */
/* TODO: they should not be hardcoded but generated by Kimdba */
var NbColumns=5;    
var ThumbnailsSize  = 128;   /* TODO: not hardcoded */
var MaxImagesInAPage= 10;   /* TODO: not hardcoded */
var AvailableImagesSize= [ "320", "640", "800", "1024"", "fullsize" ];
var AvailableResolutions= [ "320x200" , "640x480" , "800x600" , "1024x768   "  , "fullsize" ];



function getCategories() {
    var res=new Object; <xsl:apply-templates select="options/option" mode="category" /> return res;
}
function getImages() {
    var index=0;
    var res=new Array(<xsl:value-of select="count(//image)"/>);
    var categoryValue;


    Debug( "getImages() Dbut" );
    <xsl:apply-templates select="images/image"  />
    Debug( "getImages() Fin Analyse de {"+index+"} Images" );
    return res;
}

function getAllMembers() {
    // recursivly get a list of all members of a group
    // TODO: not recursive for now
    return this.members;
}
function group(optionGroup,member) {
    this.optionGroup=optionGroup;
    this.members=[ member ];
    this.getAllMembers=getAllMembers;
}

function getMemberGroups() {
    var res=new Object;
    var msg="getMemberGroups() Start\\n";
    Debug( msg );
<xsl:apply-templates select="member-groups/member" />
    return res;
}

/* We want to know which images have a given value value of an option (eg. "Keywords" => "holiday" ) */
function imagesInACategory() {
    Debug( "imagesInACategory(): start" );
    <xsl:apply-templates select="." mode="backref" />
}
    </xsl:template>


    <!-- TODO The complexity of this algorithm sucks. If someone wants to mess with XSLT code... -->
    <xsl:template match="KimDaBa" mode="backref">
	<xsl:output indent="no"/>
	<xsl:variable		name="CategoryOptions"	select="options/option/value" />
	<xsl:for-each	select="images/image">
	    <xsl:variable   name="position" select="position()-1" />
	    <xsl:for-each   select="options/option">
		<xsl:variable name="i" select="."/>
		<xsl:for-each select="$CategoryOptions[../@name=$i/@name]" >
		    <xsl:if test="$i/value/@value = @value"> 
Categories["<xsl:value-of select="../@name"/>"].values[<xsl:value-of select="position()-1"/>].images.push(<xsl:value-of select="$position"/>) ; </xsl:if>
		</xsl:for-each>
	    </xsl:for-each>
	</xsl:for-each>
    </xsl:template>
			
		    

<xsl:template match="member">
    if (res["<xsl:value-of select="@group-name"/>"]) {
	res["<xsl:value-of select="@group-name"/>"].members.push("<xsl:value-of select="@member"/>");
    } else {
	res["<xsl:value-of select="@group-name"/>"]=new group( "<xsl:value-of select="@option-group"/>", "<xsl:value-of select="@member"/>");
    }
</xsl:template>

    <xsl:template match="option" mode="category" >
    Debug( "getCategories() : <xsl:value-of select="@name"/>" );
    res["<xsl:value-of select="@name"/>"]=
    {
	icon:"<xsl:value-of select="@icon"/>", name:"<xsl:value-of select="@name"/>", show:"<xsl:value-of select="@show"/>", text:"<xsl:value-of select="@next"/>", 
	values:
	[
<xsl:apply-templates select="value" mode="category" />
	]
    };
    </xsl:template>

    <xsl:template match="value" mode="category" >
	    { value:"<xsl:value-of select="@value"/>",				images:new Array} <xsl:if test="position()!=last()">,</xsl:if> 
    </xsl:template>


<xsl:template match="image">
    res[index]={
	monthFrom:"<xsl:value-of select="@monthFrom"/>", dayFrom:"<xsl:value-of select="@dayFrom"/>", yearTo:"<xsl:value-of select="@yearTo"/>", 
	monthTo:"<xsl:value-of select="@monthTo"/>", 	file:"<xsl:value-of select="@file"/>" , label:"<xsl:value-of select="@label"/>" , 
	angle:"<xsl:value-of select="@angle"/>" , dayTo:"<xsl:value-of select="@dayTo"/>" , yearFrom:"<xsl:value-of select="@yearFrom"/>" , 
	description:"<xsl:value-of select="@description"/>", options:new Array()
    } ;
    res[index]["options"] = [
<xsl:apply-templates select="options/option" mode="images" />
    ];
    index++;
</xsl:template>

<xsl:template match="option" mode="images" >
	{ name:"<xsl:value-of select="@name"/>",	values:[	<xsl:apply-templates select="value" mode="images" />	] } <xsl:if test="position()!=last()">,</xsl:if> 
</xsl:template>

<xsl:template match="value" mode="images" > "<xsl:value-of select="@value"/>" , </xsl:template>

    
</xsl:stylesheet>
