/* Global variables */
var DebugLevel=2;
var Session;


/* List of categories and their attributes */
var Categories	= new getCategories();
Debug( "{"+Categories["Keywords"]+"} {"+Categories.Keywords.values[0].value+"}" , 4);

/* List of images and their attributes */
var Images	= new getImages();
imagesInACategory();
with( Images[0].options[0] ) {
    Debug( "name={"+name+"} values={"+values[0]+","+values[1]+"}" , 5);
}

/* List of the member groups */
var MemberGroups = new getMemberGroups();


/* merge_and()
    IN : a _sorted_ array Array1, and an array Array2,
    Result: A sorted array with all elements that were both in Array1 and Array2.
    Side effect : b is sorted too
*/
function compareNumbers(a, b) {
   return a - b
}
function merge_and( Array1, Array2) {
    var i1=0; var i2=0;
    res=new Array();
    Array2.sort(compareNumbers);
    while(true)
    {
	if ( (Array2.length==i2) || (Array1.length==i1) ) {
	    return res
	}
	if ( Array1[i1] < Array2[i2] ) {
	    i1++;
	} 
	else if (Array1[i1] > Array2[i2] ){
	    i2++;
	} 
	else {	/* Same element */ 
	    res.push( Array1[i1] );
	    i1++;
	    i2++;
	}
    }
    return res;
}
/* merge_or()
    IN : a _sorted_ array Array1, and an array Array2,
    Result: A sorted array with all elements that were in Array1 or Array2 without duplicates
*/
function merge_or( Array1, Array2) {
    var i1=0; var i2=0;
    res=new Array();
    Array2.sort();
    //alert(Array2);
    while(true)
    {
	if (Array2.length==i2){
	    return res.concat(Array1.slice(i1));
	}
	if (Array1.length==i1) {
	    return res.concat(Array2.slice(i2));
	}
	if ( Array1[i1] < Array2[i2] ) {
	    res.push( Array1[i1] );
	    i1++;
	} 
	else if (Array1[i1] > Array2[i2] ){
	    res.push( Array2[i2] );
	    i2++;
	} 
	else {	/* Same element */ 
	    res.push( Array1[i1] );
	    i1++;
	    i2++;
	}
    }
    return res;
}

// given a list of ["Madrid","Barcelona",..] of possible values of a category "Locations"
// returns a list of index of every Image with one of this value
function imagesInGroup(category,values) {
    var res=new Array();
    if (!Categories[category]) {
	Debug("merge_or() Categories[\"" + category + "\"] does not exist", 1);
	return res;
    }
    var o=Categories[category].values;
    var msg="";
    for (var i in o) {
	for (var j in values) {
	    if (i==0) { msg+=" ["+values[j]+"]"}
	    if (values[j] == o[i].value) {
		for(k in o[i].images) {
		    res.push(o[i].images[k]);
		}
	    }
	}
	msg+=" ("+o[i].value+")";
    }
    // TODO handle duplicates :	=> done in merge_and()
    Debug("imagesInGroup() values="+values+"  res="+res+"\n"+msg, 3);
    return res;
}
//var n = new Array();
//n=merge_or( [  ] , [] );			    Debug ("merge_or(): "+n.join() , 1); 
//n=merge_or( [  ] , [7 , 0, 1, 5, 9] );		    Debug ("merge_or(): "+n.join() , 1); 
//n=merge_or( [ 1,2,3,4,5,6 ] , [] );		    Debug ("merge_or(): "+n.join() , 1); 
//n=merge_or( [ 1,2,3,4,5,6 ] , [7 , 0,  9] );	    Debug ("merge_or(): "+n.join() , 1); 
//n=merge_or( [ 1,2,3,4,5,6 ] , [7 , 0, 1, 5, 9] );  Debug ("merge_or(): "+n.join() ,  1); 
//n=merge_or( [ 1,2,3,4,5,6 ] , [ 1,2,3,4,5,6 ]);    Debug ("merge_or(): "+n.join() ,  1); 
//n=merge_or( [0, 1,2,3,4,5,6 ] , [ 0,1,2,0,1 ]);    Debug ("merge_or(): "+n.join() ,  1); 

/* Given a search in the form Persons=Spiff&Anne Helene;Chicago|Santa Clara,
 * return an array of the imgages matching this search 
 */
function imagesMatching( Search ) {
    var o = new splitValidArgs( Search);
    if (o) {
	return o.Images;
    }
}

function defaultArray() 
{
    var res = new Array( Images.length );
    for (var i=0; i<res.length ; i++) { res[i]=i; }
    return res;
}
function defaultSession () 
{
	/* Default values */
	this.Pref={
	    Index:0, 
	    Start:0 , 
	    End:MaxImagesInAPage, 
	    Category:"Keywords", 
	    ImageSize:"",
	    I:0
	};
	this.Images=defaultArray();
	this.Search={};
	this.String="";
};

/* Read the URL et set the Session Variable according to it */
function parseURL() {
    var Search;

    // To handle URIs with filename :
    if (decodeURI) {
	decoded=decodeURI( window.location.href );
	Search=decoded.split("?")[1];
    } else {
	Search=window.location.href.split("?")[1];
    }
    if (!Search)    { return new defaultSession(); }
    var res;
    if (arguments.length==0) {
	res=splitValidArgs( Search );
    } else {
	res=splitValidArgs( Search , arguments[0]);
    }
    return res;
}

/*  Take the part of the url after the '?' and returns an object of the type of Session with the valid fields :
    res = splitValidArgs( 
	"Patou=prout;Locations=prout;Persons=Spiff|Jesper;Persons=Anne Helene;Locations=Grand Canyon:Start=10:Category=Persons");
	    
*/
function splitValidArgs (String) {
    var msg1="Categories recognized : ";
    var msg2="Categories Unrecognized : ";
    var msg3="Values recognized: ";
    var msg4="Values unrecognized: ";
    
    var res=new defaultSession();
    
    var debug=3;
    if (arguments[1]) { debug=1 }

    terms=String.split(";");

    for (var i in terms) {
	var o,key,value;

	keyValue=terms[i].split("=");	
	key=keyValue[0];
	Debug("i=\""+i+"\" keyValue=#"+keyValue.join()+"#"	, 5);
	if ( (key=="") || (keyValue[1]=="") )	{ 
	    continue;
	}
	try {
	    var value=validateSessionArgument(  key, keyValue[1]) ;
	    res.Pref[key] = value;
	    continue;
	}
	catch(error) {
	// Looks like this argument is here for the search
	try {
	    /* looks like a valid search */
	    o=Categories[key]["values"];
	}
	catch(error) {
	    /* Categories[key]["values"] don't exist */
	    msg2+=" \""+key+"\" ";
	    continue;
	}
	}

	msg1+= " \""+key+"\" , ";

	/* Handle ANDed and ORed value like for example: */
	/* Persons=Spiff|Jesper&Anne Helene */
	values_or=keyValue[1].split("|");
	if (debug) { Debug("values_or="+values_or, 3);}
	var array_or = new Array();
	res.Search[key]="";
	for( var value_or in values_or) {
	    var values_and=values_or[value_or].split("&");
	    var string_and="";
	    var array_and=defaultArray();
	    for (var value_and in values_and) {
		value=values_and[value_and];

		/* Ok, now, we try to see if it's a valid value */
		var recognized=false;
		for (var j in o) {
		    if (o[j].value == value) {
			recognized=true;
			msg3+=" (\""+key+"\" => \""+o[j].value+"\") ";
			Debug( "RES(\""+key+"\" => \""+o[j].value+"\") = "+o[j].images.join() ,4);
			array_and=merge_and( array_and, o[j].images);
		    }
		}
		if (!recognized) {
		    try {
		    // OK, then, it's perhaps a group ?
		        var oo=MemberGroups[value];
			Debug("value="+value+" o="+o, 3);
			recognized=1;
		    }
		    // No, it's not !
		    catch(error) {
			msg4+=" (\""+key+"\" => \""+value+"\") ";
		    }
		    if (recognized) {
			var members=oo.getAllMembers();
			var r=new Array();
			//res.String+= ";" + key + "=" + value ;
		        Debug( "splitValidArgs() o.optionGroup=\""+ oo.optionGroup+ "\" and  o.members=\"" + members + "\"" , 4);
			msg3+=" (\""	+ key+"\" => \"" +
			    oo.optionGroup + "==[ " + members + "]";
			var img=imagesInGroup( key,  members);
			array_and=merge_and( array_and, img);
			
		    }
		}
		if (recognized) {
		    if (value_and!=0) { string_and+="&"; }
		    string_and+=value;
		}
	    }
	    array_or=merge_or(array_or,array_and);
	    if (string_and!="") {
		if (res.Search[key]!="") {
		    res.Search[key]+="|";
		}
		res.Search[key]+=string_and;
	    }
	}
	res.Images=merge_and( res.Images, array_or);
    }
    validateEnd(res);
    Debug( "splitValidArgs() \""+String+"\") \n"+msg1 + "\n" + msg2 + "\n" + msg3 + "\n" + msg4 + "\n"	, 5);
    Debug( "Rsultat de la recherche de ( \""+String+"\") \n" + res.Images.join() +
	    "\nValidated search is : "+res.String			    	, debug);
    return res;
}

function validateSessionArgument( key, value) {
    var res;
    if (key=="ImageSize")
    {
	var found=0;
	for(var i in AvailableImagesSize) {
	    if (AvailableImagesSize[i]==value) {
		return value;
	    }
	}
	throw "bap";
    }
    if	(  (key=="I") || (key=="Start") || (key=="End") || (key=="ImageNo")  ) {
	res=parseInt( value);
	if (!isNaN(res)) { 
	    return (res>=0) ? (res) : (-res);
	}
	throw "bep";
    } 
    else if (key=="Category") {
	if (Categories[value]) {
	    return value;
	}
	throw "bip";
    }
    throw "bop";
}

// perform additional verification that we can do only
// once we have parsed the entire url
function validateEnd(s) {
    //var msg="";
    var found=0;
//    alert("1 s.Pref.Start="+s.Pref.Start+" s.Pref.End="+s.Pref.End+" s.Pref.I="+s.Pref.I);
    if (s.Pref.End<=s.Pref.Start) { //msg+="a ";
	s.Pref.End=s.Pref.Start + MaxImagesInAPage;
    } 
    if (s.Pref.End>s.Pref.Start+ MaxImagesInAPage) { //msg+="b ";
	s.Pref.End = s.Pref.Start+ MaxImagesInAPage;
    }
    if (s.Pref.End>s.Images.length) { //msg+="c ";
        s.Pref.End=s.Images.length;
    }
    /* TODO: it makes perhaps sens to allow here I to be
	outside [Start..End[
    This way, we are able to see all images without coming back
    back to Kimdaba.html */
    if (s.Pref.I <  s.Pref.Start)   {  //msg+="f ";
	s.Pref.I=s.Pref.Start 
    }
    //if (s.Pref.I >= s.Pref.End)	    {  //msg+="g";
    //    s.Pref.I=s.Pref.End-1   
    //}
    //if (msg) { alert(msg);}

    //alert("2 s.Pref.Start="+s.Pref.Start+" s.Pref.End="+s.Pref.End+" s.Pref.I="+s.Pref.I);
    // Ok, it's time to construct res.String, the validated search
    var begin=true;
    for (var key in s.Search) {
	if (s.Search[key]=="") { continue;}
	if (!begin) { s.String+=";" }
	s.String+= key + "=" + (s.Search[key]) ;
	begin=false;
    }
}

//imagesMatching("");				    /* 24	    */
//imagesMatching("C'est vraiment n'importe quoi");    /* 24	    */
//imagesMatching("Patou=prout;Persons=prout");	    /* 24	    */
//imagesMatching("Persons=Spiff");		    /* 3 rsultats  */
//imagesMatching("Patou=prout;Locations=prout;Persons=Spiff");		    /* 3 rsultats  */
//imagesMatching("Keywords=beers");		    /* img019 */
//imagesMatching("Persons=Anne Helene;Locations=Grand Canyon");    /* img023 img015 */

function Debug(message) {
    var level;
    if (arguments[1]) {
	level=arguments[1];
    } else {
	level=3;
    }
    if (DebugLevel>=level) {
	alert(message);
    }
}
function DebugSession(level) {
    if (DebugLevel<level) { return;}
    msg = "Valeur de Session...\n";
    msg+="Session.String=\"" +	    Session.String  + "\"\n";   
    msg+="Session.Images=\"" +	    Session.Images.join()+ "\"\n";   
    msg+="Session.Pref.Category=\"" +    Session.Pref.Category+ "\"\n";   
    msg+="Session.Pref.ImageSize=\"" +   Session.Pref.ImageSize	+ "\"\n";   
    msg+="Session.Pref.Start=\"" +	    Session.Pref.Start	+ "\"\n";   
    msg+="Session.Pref.End=\"" +	    Session.Pref.End		+ "\"\n";   
    msg+="Session.Pref.I=\"" +	    Session.Pref.I		+ "\"\n";   
    msg+="Session.Search={" ;
    for (var i in Session.Search) {
	msg+="\"" + i + "\" => \"" + Session.Search[i] + "\"" ;
    } 
    msg+="}\n";
    alert(msg);
}


function get(id) {
    var o=document.getElementById(id);
    return o;
}


// Merge basePage, the infos contained in Session and eventually an additional field
// return a node with the good href field
function generateAnchor(basePage, additional) 
{
    n2=document.createElement("a");
    n2.setAttribute( "href", generateURL( basePage, additional) );
    return n2;
} 

function generateURL(basePage, additional) 
{
    var url=basePage + "?" ;

    var res=splitValidArgs( additional );
    //var a=Session;
    //Session=res;
    //DebugSession(1);
    //Session=a;
    if (basePage=="Viewer.html") {
	url+="I="+res.Pref.I+";";
    }
    if (Session.String)	{ url+=Session.String	+ ";" }
    if (res.String)	{ url+=res.String	+ ";" }

    if (res.Pref.ImageSize!="")		{ url+="ImageSize="+res.Pref.ImageSize   + ";" }
    else if (Session.Pref.ImageSize!=""){ url+="ImageSize="+Session.Pref.ImageSize   + ";"    }

    if ( (basePage=="ThumbnailView.html") || (basePage=="Viewer.html") )
    {
	var nb=Session.Images.length;	
	var start=Session.Pref.Start;	
	var   end=Session.Pref.End;	
	if (!Session.Pref.Start)	{ start=0 ; }
	if ( Session.Pref.Start>=nb)	{ start=nb;}			    // TODO
	if (res.Pref.Start)		{ start=res.Pref.Start;}
	if ( !Session.Pref.End )	{ end=start+MaxImagesInAPage; }
	if (Session.Pref.End>nb)	{ end=nb;}		    // TODO
	//BUG if (res.Pref.End)		{ end=res.Pref.End;}
	url+="Start="+ start + ";";
	url+="End="  + end   + ";";
    }

    if (basePage=="Category.html") {
	if (res.Pref.Category)	{ url+="Category="+ res.Pref.Category+";" ; }
	else if (Session.Pref.Category)	{ url+="Category="+ Session.Pref.Category+";" ; }
    }

    url.replace(  /;$/ , "" );
    url.replace(  /^;/ , "" );
    return url;
}

// Basic function to display infs about the context
function displayTop() {
    text=Session.String;
    text=text.replace( /^ *;*/ , "" );
    text=text.replace( / *;* *$/ , "" );
    text=text.replace( /\;/g , " / " );
    text=text.replace( /\|/g , " or " );
    text=text.replace( /\&/g , " and " );
    if (text=="") { text="**ALL PICTURES**" ; }
    get( "bottom_right" ).firstChild.data = "Total : "+Images.length;
    get( "bottom_left"  ).firstChild.data = text;
}

// Resolutions
// Parameters : the name of the page from which it is called
//<td id="resolutions" > 800x600 <a href="img001-fullsize.html">full size</a></td> --> //
function displayResolutions( basePage) {
    var node=get( "resolutions" );
    if (!node) { 
	alert("displayResolutions() No elements <td id=\"resolutions\"> found");
	return;
    }
    for (var i in AvailableImagesSize) {
	if (AvailableImagesSize[i]==Session.Pref.ImageSize) {
	    node.appendChild( document.createTextNode( "  "+AvailableImagesSize[i]+"  "));
	} else {
	    var res= generateAnchor( basePage, "ImageSize="+AvailableImagesSize[i]);
	    res.appendChild( document.createTextNode( "  "+AvailableResolutions[i]+"  "));
	    node.appendChild( res );
	}
    }
}
